<template>
  <div class="login-wrapper">
    <div class="login-form-wrapper">
      <h1>Mifuka</h1>
      <form class="login-form">
        <h3>Sign In</h3>

        <div class="form-group">
          <label>Username</label>
          <label>
            <input type="text" name="username" v-model="username" />
          </label>
        </div>

        <div class="form-group">
          <label>Password</label>
          <label>
            <input type="password" name="password" v-model="password" />
          </label>
        </div>

        <button type="submit" @click="submitForm">Sign In</button>
      </form>
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent, ref } from 'vue';
import useLogin from '@/composable/useLogin';
import { useRouter } from 'vue-router';

export default defineComponent({
  name: 'Login.vue',
  setup() {
    const router = useRouter();
    const username = ref('');
    const password = ref('');
    const { authenticate } = useLogin();

    async function submitForm(e: Event) {
      e.preventDefault();
      const isAuthenticated = await authenticate(username.value, password.value);

      if (isAuthenticated) {
        try {
          await router.push('/');
        } catch (e) {
          console.log('Error Nav ', e);
        }
      }
    }

    return {
      username,
      password,

      submitForm,
    };
  },
});
</script>

<style scoped lang="scss">
.login-wrapper {
  width: 100%;
  height: 90vh;
  display: flex;
  place-content: center;
  place-items: center;

  .login-form-wrapper {
    border-radius: var(--border-radius);
    width: 400px;
    height: 350px;
    display: flex;
    flex-direction: column;
    place-items: center;
    justify-content: space-around;
    background: burlywood;
    box-shadow: rgba(0, 0, 0, 0.15) 0px 15px 25px, rgba(0, 0, 0, 0.05) 0px 5px 10px;

    .login-form {
      text-align: center;
      height: 70%;
      width: 70%;

      .form-group {
        display: flex;
        justify-content: space-evenly;
        margin-bottom: 20px;
      }
    }
  }
}
</style>
